SCTI/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from buses.views import index

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', index, name="index"),
    path('buses/', include('buses.urls'), name='buses'),
    path('auth/', include('buses_auth.urls'), name='auth'),

] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

buses/urls.py
from django.urls import path
from buses import views


urlpatterns = [
    path('bus_add', views.bus_add, name="bus_add"),
    path('bus_edit/<int:pk>/', views.bus_edit, name="bus_edit"),
    path('bus_list', views.bus_list, name="bus_list"),
    path('bus_del/<int:pk>/', views.bus_del, name="bus_delete"),
    path('crewmember_add', views.crewmember_add, name="crewmember_add"),
    path('crewmember_edit/<int:pk>/', views.crewmember_edit, name="crewmember_edit"),
    path('crewmember_list', views.crewmember_list, name="crewmember_list"),
    path('crewmember_del/<int:pk>/', views.crewmember_del, name="crewmember_delete"),
    path('trip_add', views.trip_add, name="trip_add"),
    path('trip_edit/<int:pk>/', views.trip_edit, name="trip_edit"),
    path('trip_list', views.trip_list, name="trip_list"),
    path('trip_del/<int:pk>/', views.trip_del, name="trip_delete"),
]

buses/models.py
# -*- coding: utf-8 -*-
from django.db import models
from django.contrib.auth.models import User
from django.utils import timezone
from django.utils.encoding import python_2_unicode_compatible
# Create your models here.
from buses.defines import CREW_TYPE_CHOICES
@python_2_unicode_compatible
class CrewMember(models.Model):
    user = models.OneToOneField(User,null=True,default=None,on_delete=models.SET_NULL)    
    rut = models.IntegerField(default=0,blank=True,null=True,verbose_name="Rut")
    dv = models.CharField(max_length=1,default="",blank=True,null=True,verbose_name="Dígito Verificador")
    email = models.CharField(max_length=150,default="",verbose_name='Email')
    phone = models.IntegerField(default=0,blank=True,null=True,verbose_name='Teléfono')
    name = models.CharField(max_length=100,verbose_name='Nombre')
    last_name = models.CharField(max_length=100,verbose_name='Apellido')
    img = models.ImageField(upload_to="profile_pics",default=None,verbose_name='Imagen de Perfíl')
    role = models.CharField(max_length=2,choices=CREW_TYPE_CHOICES,default="CO",verbose_name="Rol")
    def __str__(self):
        return "%s %s %d-%s" % (self.name,self.last_name,self.rut,self.dv)

class Bus(models.Model):
    model = models.CharField(max_length=100,verbose_name="Modelo")
    patent = models.CharField(max_length=100,verbose_name="Patente")
    kms = models.IntegerField(default=0,verbose_name="Kilometraje")
    seats = models.IntegerField(default=0,verbose_name="Cant. Asientos")

    def __str__(self):
        return "%s - %s" % (self.model,self.patent)

@python_2_unicode_compatible
class Trip(models.Model):
    bus = models.ForeignKey(Bus,null=True,default=None,on_delete=models.CASCADE,verbose_name="Bus")
    asisstant1 = models.ForeignKey(CrewMember,default=None,null=True,on_delete=models.SET_NULL,verbose_name="Asistente de viaje 1",related_name="asistente_1")
    asisstant2 = models.ForeignKey(CrewMember,default=None,null=True,on_delete=models.SET_NULL,verbose_name="Asistente de viaje 2",related_name="asistente_2")
    source = models.CharField(max_length=300,verbose_name='Desde')
    destination = models.CharField(max_length=300,verbose_name='Hasta')
    start_time = models.DateTimeField(default=timezone.now,verbose_name='Hora de partida')
    arrival_time = models.DateTimeField(default=timezone.now,verbose_name="Horario de llegada")
    bus_driver = models.ForeignKey(CrewMember,default=None,null=True,on_delete=models.SET_NULL,verbose_name="Conductor")

    def __str__(self):
        return "De:%s Hasta:%s - %s" % (self.source,self.destination,self.start_time)

class Stop(models.Model):
    trip = models.ForeignKey(Trip,null=True,default=None,on_delete=models.CASCADE)
    location = models.CharField(max_length=200)
    arrival = models.DateTimeField(default=timezone.now)
    leave = models.DateTimeField(default=timezone.now)

class Passanger(models.Model):
    name = models.CharField(max_length=100,default="")
    rut = models.IntegerField(default=0)
    dv = models.CharField(max_length=1,default="")
    email = models.CharField(max_length=150,default="")
    phone = models.IntegerField(default=0)

class PassangerTicket(models.Model):
    seat = models.CharField(max_length=5)
    trip = models.ForeignKey(Trip,default=None,null=True,on_delete=models.CASCADE)
    passanger = models.ForeignKey(Passanger,default=None,null=True,on_delete=models.CASCADE)
    used = models.IntegerField(default=0)

buses/forms.py
from django import forms
from buses.models import Bus,Trip,Passanger,CrewMember



class BusForm(forms.ModelForm):
    class Meta:
        model = Bus
        fields = ['model', 'patent', 'kms', 'seats']

class CrewMemberForm(forms.ModelForm):
    class Meta:
        model = CrewMember
        fields = ['name', 'last_name','img','phone', 'email','rut','dv','role']

class TripForm(forms.ModelForm):
    class Meta:
        model = Trip
        fields = ['bus', 'source', 'destination', 'start_time','bus_driver']
        widgets = {
            'start_time': forms.DateInput(attrs={'class':'datepicker'}),
        }

buses/views.py
# -*- coding: utf-8 -*-
from django.shortcuts import render
from buses.forms import BusForm, CrewMemberForm, TripForm
from buses.models import Bus,Trip,CrewMember,Stop,Passanger
from django.shortcuts import redirect
from django.contrib.auth.decorators import login_required
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger
from django.urls import reverse
from django.http import HttpResponseRedirect
from django.contrib.auth.models import User
from django.utils import timezone
import datetime
from unidecode import unidecode
# Create your views here.
@login_required(login_url='/auth/login')
def index(request):
    data = {
    }
    user_type = "AD"
    print(request.user)
    try:
        if request.user.crewmember.role == "CO":
            user_type = "CO"
        else:
            user_type = "AS"

    except AttributeError:
        pass

    lista = []
    hoy = timezone.now()
    for trip in Trip.objects.all():
        if (trip.arrival_time - hoy).total_seconds() < 0:
            lista.append(trip)

    if len(lista) == 0:
        lista = "False"    
    print("User_type ",user_type)
    data['user_type'] = user_type
    data['list'] = lista
    template_name = 'index.html'
    return render(request,template_name,data)

@login_required(login_url='/auth/login')
def bus_add(request):
    data = {}
    if request.method == "POST":
        data['form'] = BusForm(request.POST)
        if data['form'].is_valid():
            # aca el formulario valido
            data['form'].save()

            return redirect('bus_add')

    else:
        data['form'] = BusForm()

    data["titulo"] = "Agregar"
    template_name = 'buses/add_bus.html'
    return render(request, template_name, data)

@login_required(login_url='/auth/login')
def bus_list(request):
    data = {}

    # SELECT * FROM player
    object_list = Bus.objects.all().order_by('-id')

    paginator = Paginator(object_list, 10)
    page = request.GET.get('page')

    try:
        data['object_list'] = paginator.page(page)
    except PageNotAnInteger:
        # If page is not an integer, deliver first page.
        data['object_list'] = paginator.page(1)
    except EmptyPage:
        data['object_list'] = paginator.page(paginator.num_pages)

    template_name = 'buses/list_bus.html'
    return render(request, template_name, data)

@login_required(login_url='/auth/login')
def bus_del(request,pk):
    bus = Bus.objects.get(pk=pk)
    bus.delete()

    return HttpResponseRedirect(reverse("bus_list"))

@login_required(login_url='/auth/login')
def bus_edit(request,pk):
    data = {}
    bus = Bus.objects.get(pk=int(pk))
    if request.method == "POST":
        data['form'] = BusForm(request.POST, request.FILES, instance=bus)
        if data['form'].is_valid():
            # aca el formulario valido
            data['form'].save()
            return redirect('bus_list')

    else:
        print("Este es el Bus ", bus)
        data['form'] = BusForm(instance=bus)

    data["titulo"] = "Editar"
    template_name = 'buses/add_bus.html'
    return render(request, template_name, data)

@login_required(login_url='/auth/login')
def crewmember_add(request):
    data = {}
    if request.method == "POST":
        data['form'] = CrewMemberForm(request.POST,request.FILES)
        username = request.POST["rut"]
        password = request.POST["phone"]
        print("Esta esl a password: ",password)
        user = User.objects.create_user(username=username,password=password)
        user.save()
        if data['form'].is_valid():
            # aca el formulario valido
            crewmember=data['form'].save()
            crewmember.user = user
            crewmember.save()
            return redirect('crewmember_add')

    else:
        data['form'] = CrewMemberForm()

    data["titulo"] = "Agregar"
    template_name = 'conductores/add_crewmember.html'
    return render(request, template_name, data)

@login_required(login_url='/auth/login')
def crewmember_list(request):
    data = {}

    # SELECT * FROM player
    object_list = CrewMember.objects.all().order_by('-id')

    paginator = Paginator(object_list, 10)
    page = request.GET.get('page')

    try:
        data['object_list'] = paginator.page(page)
    except PageNotAnInteger:
        # If page is not an integer, deliver first page.
        data['object_list'] = paginator.page(1)
    except EmptyPage:
        data['object_list'] = paginator.page(paginator.num_pages)

    template_name = 'conductores/list_crewmember.html'
    return render(request, template_name, data)

@login_required(login_url='/auth/login')
def crewmember_del(request,pk):
    crewmember = CrewMember.objects.get(pk=pk)
    crewmember.delete()

    return HttpResponseRedirect(reverse("crewmember_list"))

@login_required(login_url='/auth/login')
def crewmember_edit(request,pk):
    data = {}
    crewmember = CrewMember.objects.get(pk=int(pk))
    if request.method == "POST":
        data['form'] = CrewMemberForm(request.POST, request.FILES, instance=bus)
        if data['form'].is_valid():
            # aca el formulario valido
            data['form'].save()
            return redirect('crewmember_list')

    else:
        print("Este es el CrewMember ", crewmember)
        data['form'] = CrewMemberForm(instance=crewmember)

    data["titulo"] = "Editar"
    template_name = 'conductores/add_crewmember.html'
    return render(request, template_name, data)

@login_required(login_url='/auth/login')
def trip_add(request):
    data = {}
    if request.method == "POST":
        bus = Bus.objects.get(pk=request.POST['buspk'])
        source = request.POST['source']
        destination = request.POST['destination']
        start_time = request.POST['start_time']
        bus_crewmember = CrewMember.objects.get(pk=request.POST['crewmemberpk'])
        return redirect('trip_add')
    else:
        data['buses'] = Bus.objects.all()
        data['conductores'] = CrewMember.objects.filter(role="CO").all()
        data['asistentes'] = CrewMember.objects.filter(role="AS")
    data["titulo"] = "Agregar"
    template_name = 'viajes/add_trip.html'
    return render(request, template_name, data)

@login_required(login_url='/auth/login')
def trip_list(request):
    data = {}

    # SELECT * FROM player
    object_list = Trip.objects.all().order_by('-id')

    paginator = Paginator(object_list, 10)
    page = request.GET.get('page')

    try:
        data['object_list'] = paginator.page(page)
    except PageNotAnInteger:
        # If page is not an integer, deliver first page.
        data['object_list'] = paginator.page(1)
    except EmptyPage:
        data['object_list'] = paginator.page(paginator.num_pages)

    template_name = 'conductores/list_crewmember.html'
    return render(request, template_name, data)

@login_required(login_url='/auth/login')
def trip_del(request,pk):
    trip = Trip.objects.get(pk=pk)
    trip.delete()

    return HttpResponseRedirect(reverse("crewmember_list"))

@login_required(login_url='/auth/login')
def trip_edit(request,pk):
    data = {}
    trip = Trip.objects.get(pk=int(pk))
    if request.method == "POST":
        data['form'] = TripForm(request.POST, request.FILES, instance=trip)
        if data['form'].is_valid():
            # aca el formulario valido
            data['form'].save()
            return redirect('trip_list')

    else:
        print("Este es el trip ", trip)
        data['form'] = TripForm(instance=trip)

    data["titulo"] = "Editar"
    template_name = 'viajes/add_trip.html'
    return render(request, template_name, data)

buses/templates/viajes/add_trip.html
{% extends "base.html" %}
{% load bootstrap4 %}
{% load static %}
{% block title %}
{{titulo}} un Viaje 
{% endblock title%} 
{% block css %}
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.0.0/css/tempusdominus-bootstrap-4.min.css"/> 
<link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6-rc.0/css/select2.min.css" rel="stylesheet" />
{% endblock css %} {% block content %}
<div class="row">
	<div class="col-lg-8 offset-lg-2 col-md-8 offset-md-2">
		<h1 class="text-center" style="margin-top:30px;">{{titulo}} Viaje</h1>
		<hr>
		<form id="formulario" action="" method="POST" enctype="multipart/form-data">
			{% csrf_token %}
			<div class="form-group row">
				<label class="col-md-3 col-form-label" for="id_bus">Bus</label>
				<div class="col-md-9">
					<select name="bus" title="" required="" id="id_bus" class="form-control select2">
						{% for bus in buses %}
						<option value='{{bus.pk}}'>{{bus}}</option>
						{% endfor %}
					</select>
				</div>
			</div>
			<div class="form-group row">
				<label class="col-md-3 col-form-label" for="id_source">Desde</label>
				<div class="col-md-9">
					<input name="source" class="form-control" maxlength="300" required="" placeholder="Desde" title="" id="id_source" type="text">
				</div>
			</div>
			<div class="form-group row">
				<label class="col-md-3 col-form-label" for="id_destination">Hasta</label>
				<div class="col-md-9">
					<input name="destination" class="form-control" maxlength="300" required="" placeholder="Hasta" title="" id="id_destination"
					 type="text">
				</div>
			</div>
			<div class="form-group row">
				<label class="col-md-3 col-form-label" for="id_start_time">Hora de partida</label>
				<div class="col-md-9">
					<div class="input-group date" id="datetimepicker1" data-target-input="nearest">
						<input type="text" class="form-control datetimepicker-input" data-target="#datetimepicker1" required/>
						<div class="input-group-append" data-target="#datetimepicker1" data-toggle="datetimepicker">
							<div class="input-group-text"><i class="fa fa-calendar"></i></div>
						</div>
					</div>
				</div>
			</div>
			<div class="form-group row">
				<label class="col-md-3 col-form-label" for="id_bus_driver">Conductor</label>
				<div class="col-md-9">
					<select name="bus_driver" title="" required id="id_bus_driver" class="form-control select2">
						{% for driver in conductores %}
						<option value="{{driver.pk}}">{{driver}}</option>
						{% endfor %}
					</select>
				</div>
			</div>
			<div class="form-group row">
				<label class="col-md-3 col-form-label" for="id_assistant_1">Asistente de Viaje</label>
				<div class="col-md-9">
					<select name="assistant_1" title="" required id="id_assistant_1" class="form-control select2">
						{% for assistant in asistentes %}
						<option value="{{assistant.pk}}">{{assistant}}</option>
						{% endfor %}
					</select>
				</div>
			</div>
			<div class="form-group row">
				<label class="col-md-3 col-form-label" for="id_assistant_2">Asistente de Viaje</label>
				<div class="col-md-9">
					<select name="assistant_2" title="" required id="id_assistant_2" class="form-control select2">
						{% for assistant in asistentes %}
						<option value="{{assistant.pk}}">{{assistant}}</option>
						{% endfor %}
					</select>
				</div>
			</div>
			<a value="Enviar" id="submit" class="btn btn-primary btn-lg btn-block" style="color:white">Enviar</a>
		</form>
		<br>
	</div>
</div>
{% endblock content %} {% block javascript %}
<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6-rc.0/js/select2.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/moment.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.0.0/js/tempusdominus-bootstrap-4.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.17.0/jquery.validate.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.17.0/additional-methods.js"></script>
<script>
	$(document).ready(function () {
		$("#vi_list").addClass("active");
		$('#datetimepicker1').datetimepicker({
			format: 'DD/MM/YYYY - HH:mm',
		});
		$("#submit").click(function(){
			if ($("#formulario").valid()){
				var data = {
					buspk: $("#id_bus").val(),
					source: $("#id_source").val(),
					destination: $("#id_destination").val(),
					start_time: $("#id_start_time").val(),
					driverpk: $('#id_bus_driver').val(),
					csrfmiddlewaretoken: '{{ csrf_token }}'
				}
				$.ajax({
					url: '{% url "trip_add" %}',
					data: data,
					type: 'POST',
					success: function (result) {
					},
					error: function () {
						swal("Error!", "Contacte a su administrador.", "warning")
					}
				});
			} else {
				$("#formulario").validate();
			}
		})
		$(".select2").select2();
	});
</script> {% endblock javascript %}

buses/templates/viajes/list_trip.html
{% extends "base.html" %}
{% block title %}
Lista de Viajes
{% endblock title %}
{% block content %}
<div class="row titulo">
	<h1>Lista de Viajes</h1>
	<div class="col-md-12">
		<div class="row">
			<div class="col-md-12">
				<input type="text" id="search" class="form-control" placeholder="Que estas buscando?...">
				<br>
			</div>
			<div class="col-md-12 m-t-1">
				<table class="table table-striped">
					<thead>
						<tr>
							<th scope="col">Patente</th>
							<th scope="col">Modelo</th>
							<th scope="col">Kilometraje</th>
							<th scope="col">Cant. Asientos</th>
							{% if request.user.is_staff %}
							<th scope="col">Acciones</th>
							{% endif %}
						</tr>
					</thead>
					<tbody id="co_table">
						{% for bus in object_list %}
						<tr>
							<td>{{bus.patent}}</td>
							<td>{{bus.model}}</td>
							<td>{{bus.kms}}</td>
							<td>{{bus.seats}}</td>
							{% if request.user.is_staff %}
							<td>
								<a class="btn btn-warning btn-sm" href="{% url 'bus_edit' bus.pk %}"><i class="fa fa-edit"></i></a>
								<a class="btn btn-danger btn-sm" href="{% url 'bus_delete' bus.pk %}"><i class="fa fa-times"></i></a>
							</td>
							{% endif %}
						</tr>
						{% endfor %}
		
					</tbody>
				</table>
			</div>
		</div>
	</div>
</div>
<div class="row">
	{% if object_list.has_next or object_list.has_previous %}
	<nav aria-label="Page navigation example">
		<ul class="pagination">
			{% if object_list.has_previous %}
			<li class="page-item">
				<a class="page-link" href="?page={{ object_list.previous_page_number }}">Previous</a>
			</li>
			{% endif %} {% for page in object_list.paginator.page_range %}
			<li class="page-item {% if object_list.number == page %}active{% endif %}">
				<a class="page-link" href="?page={{ page }}">{{ page }}</a>
			</li>
			{% endfor %} {% if object_list.has_next %}
			<li class="page-item">
				<a class="page-link" href="?page={{ object_list.next_page_number }}">Next</a>
			</li>
			{% endif %}
		</ul>
	</nav>
	{% endif %}
</div>
<!-- Button trigger modal -->
<!-- Modal -->
{% comment %} <div class="modal fade" id="detallesModal" tabindex="-1" role="dialog" aria-labelledby="DetallesDeJugadores" aria-hidden="true">
	<div class="modal-dialog modal-dialog-centered" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<h5 class="modal-title" id="exampleModalLongTitle">Información</h5>
				<button type="button" class="close" data-dismiss="modal" aria-label="Close">
				<span aria-hidden="true">&times;</span>
				</button>
			</div>
			<div class="modal-body">
				<div class="row">
					<div class="col-md-4">
						<img class="mb-4 rounded-circle" src="{% static 'index.jpg' %}" alt="" width="50%" height="50%">
					</div>
					<div class="col-md-8">
						<div class="row">
							<label for="name"></label>
						</div>
					</div>
				</div>
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
				<button type="button" class="btn btn-primary">Save changes</button>
			</div>
		</div>
	</div>
</div> {% endcomment %}
{% endblock content %}
{% block javascript %}
<script>
	$(document).ready(function(){
		$("#vi_list").addClass("active");
		
		$("#search").on("keyup", function() {
			var value = $(this).val().toLowerCase();
			$("#co_table tr").filter(function() {
				$(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
			});
		});

		$('#detallesModal').on('shown.bs.modal', function () {

		});
	});
</script> 
{% endblock javascript %}